<?php
// This file initializes Mokoala
require_once 'admin/library/com/mokoala/Mokoala.php';

// Connect to the database
MK_MySQL::connect();

// Start session & establish name-space
$session = MK_Session::getInstance();

// Get a copy of the sites config options
$config = MK_Config::getInstance();

// Define how cookies are used
$cookie = MK_Cookie::getInstance();

// Is Mokoala installed?
if( !$config->site->installed )
{
	header("Location: admin/", true, 302);
	exit;
}

// Check if user is logging in with Facebook
if($config->site->facebook->login && ( $facebook_session = $facebook->getSession() ))
{
	$user_details = $facebook->api('/me?fields=picture');


	try{
		MK_Authorizer::authorizeByFacebookId( $user_details['id'] );
		$user = MK_Authorizer::authorize();
	}
	catch( Exception $e )
	{
		$user_module = MK_RecordModuleManager::getFromType('user');
		$user = MK_RecordManager::getNewRecord($user_module->getId());
		
		if( !empty($user_details['picture']) )
		{
			$user_details['picture'] = MK_FileManager::uploadFileFromUrl( 'http://graph.facebook.com/'.$user_details['id'].'/picture?type=large', $config->site->upload_path );
		}

		$user
			->setEmail( $user_details['email'] )
			->setDisplayName( $user_details['name'] )
			->setName( $user_details['name'] )
			->setAvatar( $user_details['picture'] )
			->setType( MK_RecordUser::TYPE_FACEBOOK )
			->setFacebookId( $user_details['id'] )
			->save();

	}
	$cookie->set('login', $user->getId(), $config->site->user_timeout);
	$session->login = $user->getId();
	
	header('Location: '.($config->site->referer === $config->site->page ? $config->site->base : $config->site->referer), true, 302);
	exit;
}

// If user session has expired but cookie is still active
if( $cookie->login && empty($session->login) )
{
	$session->login = $cookie->login;
}

// Get current user
if( !empty($session->login) )
{
    MK_Authorizer::authorizeById( $session->login );
}

$user = MK_Authorizer::authorize();

?>