<?php

/*
	Loader for Mokoala
*/
$path = dirname(__FILE__);

require_once $path.'/../facebook/Facebook.class.php';

require_once $path.'/Utility/DataRenderer.class.php';
require_once $path.'/Utility/FieldHandler.class.php';
require_once $path.'/Utility/Backup.class.php';
require_once $path.'/Utility/Email.class.php';
require_once $path.'/Utility/BrandedEmail.class.php';
require_once $path.'/Utility/Message.class.php';
require_once $path.'/Utility/MetaFactory.class.php';
require_once $path.'/Utility/MetaFactoryExtra.class.php';
require_once $path.'/Utility/Paginator.class.php';
require_once $path.'/Utility/Utility.class.php';
require_once $path.'/Utility/MySQLDump.class.php';
require_once $path.'/Utility/ZipArchive.class.php';
require_once $path.'/Utility/ConfigHandler.interface.php';
require_once $path.'/Utility/ConfigHandler.class.php';
require_once $path.'/Utility/Config.class.php';
require_once $path.'/Utility/ConfigHolder.class.php';

require_once $path.'/Authorizer/Authorizer.class.php';

require_once $path.'/Cookie/Cookie.class.php';
require_once $path.'/Cookie/CookieHolder.class.php';

require_once $path.'/Calendar/Calendar.class.php';

require_once $path.'/Core/View/Head.class.php';
require_once $path.'/Core/Request.class.php';
require_once $path.'/Core/Core.class.php';
require_once $path.'/Core/Controller.class.php';
require_once $path.'/Core/View.class.php';

require_once $path.'/Database/MySQL.class.php';

require_once $path.'/Directory/Directory.class.php';

require_once $path.'/Exception/Exception.class.php';
require_once $path.'/Exception/ControllerException.class.php';
require_once $path.'/Exception/InputException.class.php';
require_once $path.'/Exception/ModuleException.class.php';
require_once $path.'/Exception/ModuleRecordException.class.php';
require_once $path.'/Exception/SQLException.class.php';
require_once $path.'/Exception/ViewException.class.php';

require_once $path.'/File/FileManager.class.php';
require_once $path.'/File/File.class.php';
require_once $path.'/File/Image.class.php';
require_once $path.'/File/ImageThumb.class.php';

require_once $path.'/Form/Validator.class.php';
require_once $path.'/Form/Form.class.php';

require_once $path.'/Module/Record.class.php';
require_once $path.'/Module/RecordManager.class.php';
require_once $path.'/Module/RecordModule.class.php';
require_once $path.'/Module/RecordModuleField.class.php';
require_once $path.'/Module/RecordModuleFieldValidation.class.php';
require_once $path.'/Module/RecordModuleManager.class.php';
require_once $path.'/Module/RecordUser.class.php';

require_once $path.'/Session/Session.class.php';
require_once $path.'/Session/SessionHolder.class.php';

require_once $path.'/globals.php';
require_once $path.'/config.php';

$config = MK_Config::getInstance();

foreach($config->db->components as $component)
{
	$module_includes_path = 'resources/components/'.$component.'/extensions';
	if( is_dir($module_includes_path) )
	{
		$module_includes = scandir($module_includes_path);
		foreach($module_includes as $module)
		{
			if($module == '.' || $module == '..')
			{
				continue;
			}

			$module_path = $module_includes_path.'/'.$module;
			if( is_file($module_path) )
			{
				require_once $module_path;
			}
		}
	}
}
?>