<?php
	require_once('_inc.php');
	$head_title = array();
	$head_title[] = 'Login';
	// If the user is already logged in then return them to the homepage
	if($user->isAuthorized()){
		header('Location: '.$config->site->base, true, 302);
		exit;
	}

	// If the user clicked the 'sign in with Facebook' link
	if( MK_Request::getQuery('platform') === 'facebook' ){
		$config = MK_Config::getInstance();
		$facebook_url = $config->facebook->getLoginUrl(array(
			'next' => MK_Utility::serverUrl($config->site->referer),
			'cancel_url' => MK_Utility::serverUrl($config->site->referer),
			'req_perms' => 'email, user_photos'
		));

		header('Location: '.$facebook_url, true, 302);
		exit;
	}

	$settings = array(
		'attributes' => array(
			'class' => 'narrow clear-fix'
		)
	);

	$structure = array(
		'email' => array(
			'label' => 'Email',
			'validation' => array(
				'email' => array(),
				'instance' => array()
			)
		),
		'password' => array(
			'label' => 'Password',
			'validation' => array(
				'instance' => array(),
			),
			'attributes' => array(
				'type' => 'password'
			)
		),
		'login' => array(
			'type' => 'submit',
			'attributes' => array(
				'value' => 'Login'
			)
		)
	);
	
	if($config->site->facebook->login)
	{
		$structure['facebook'] = array(
			'type' => 'link',
			'text' => 'Login with Facebook',
			'attributes' => array(
				'href' => 'login.php?platform=facebook'
			)
		);	
	}

	$form = new MK_Form($structure, $settings);
	
	$output = '<h2 class="narrow">Login</h2>';
	$output .= '<p class="narrow">Please enter your email address and password. If you can\'t remember then use the <a href="forgot-pass.php">forgotten password</a> form.</p>';
	if($form->isSuccessful()){
		$user = MK_Authorizer::authorizeByEmailPass(
			$form->getField('email')->getValue(),
			$form->getField('password')->getValue()
		);
		
		if($user->isAuthorized()){
			$session->login = $user->getId();
			$cookie->set('login', $user->getId(), $config->site->user_timeout);
			header('Location: '.($config->site->referer === $config->site->page ? $config->site->base : $config->site->referer), true, 302);
		}else{
			$form->getField('email')->getValidator()->addError('This username and password combination does not match our records. Please try again.');
		}
	}
	
	$output.=$form->render();

	require_once('_header.php');
	print $output;
	require_once('_footer.php');
?>