<?php
	require_once('_inc.php');
	$head_title = array();
	$head_title[] = 'Register';

	if($user->isAuthorized()){
		header('Location: '.$config->site->base, true, 302);
		exit;
	}

	// We get an instance of the users module, the email field and the display name field to make sure the given email and display name is unique
	$user_module = MK_RecordModuleManager::getFromType('user');
	$field_module = MK_RecordModuleManager::getFromType('module_field');
	$criteria = array(
		array('field' => 'module_id', 'value' => $user_module->getId()),
		array('field' => 'name', 'value' => 'email')
	);
	
	$user_email_field = array_pop( $field_module->searchRecords($criteria) );

	$criteria = array(
		array('field' => 'module_id', 'value' => $user_module->getId()),
		array('field' => 'name', 'value' => 'display_name')
	);
	
	$user_display_name_field = array_pop( $field_module->searchRecords($criteria) );

	$settings = array(
		'attributes' => array(
			'class' => 'narrow clear-fix'
		)
	);

	$structure = array(
		'display_name' => array(
			'label' => 'Display name',
			'validation' => array(
				'instance' => array(),
				'unique' => array(null, $user_display_name_field, $user_module)
			)
		),
		'email' => array(
			'label' => 'Email',
			'validation' => array(
				'email' => array(),
				'instance' => array(),
				'unique' => array(null, $user_email_field, $user_module)
			)
		),
		'password' => array(
			'label' => 'Password',
			'validation' => array(
				'instance' => array(),
			),
			'attributes' => array(
				'type' => 'password'
			)
		),
		'submit' => array(
			'type' => 'submit',
			'attributes' => array(
				'value' => 'Register'
			)
		)
	);

	
	if($config->site->facebook->login)
	{
		$structure['facebook'] = array(
			'type' => 'link',
			'text' => 'Login with Facebook',
			'attributes' => array(
				'href' => 'login.php?platform=facebook'
			)
		);	
	}

	$form = new MK_Form($structure, $settings);
	

	$output = '<h2 class="narrow">Register</h2>';
	if($form->isSuccessful()){
		
		$user = MK_RecordManager::getNewRecord($user_module->getId());
		
		$user
			->setEmail($form->getField('email')->getValue())
			->setPassword($form->getField('password')->getValue())
			->setDisplayName($form->getField('display_name')->getValue())
			->save();
		
		$session->login = $user->getId();
		$cookie->set('login', $user->getId(), $config->site->user_timeout);
		
		$output .= '<p class="alert success">Thank you for registering; you have been signed in and can <a href="edit-profile.php">make changes to your profile</a>.</p>';

	}else{
		$output .= $form->render();
	}

	require_once('_header.php');
	print $output;
	require_once('_footer.php');
?>